#include <mex/mex_parser.h>
#include <mex/mex_pdf.h>
class mexBM: public BM{
	protected:
		mxArray *data;
		mexEpdf est;
	public:
		mexBM() {};
		void from_setting(const Setting &S)  {
			Setting &So=S["object"];
			data = (mxArray*)long(So);
		} 
		void validate() {
			mexCallMATLAB(0, 0, 1, &data,  "validate");
			mxArray *tmp;
			mexCallMATLAB(1, &tmp, 1, &data, "dimensions");
			vec v=mxArray2vec(tmp);
			if (v.length()<3) {bdm_error("Three dimensions are expected in mexBM.dimensions");}
			set_dim(v(0));
			dimy = v(1);
			dimc = v(2);
		}
		void bayes(const vec &dt, const vec &cond) {
			mxArray *tmp;
			mxArray *in[3];
			in[0]=data;
			in[1]=mxCreateDoubleMatrix(dt.length(),1,mxREAL);
			vec2mxArray(dt,in[1]);
			in[2]=mxCreateDoubleMatrix(cond.length(),1,mxREAL);
			vec2mxArray(cond,in[2]);
			
			mexCallMATLAB(1, &tmp, 3, in, "bayes");
			if (data!=tmp){
				mxDestroyArray ( data );
				data = mxDuplicateArray ( tmp );
			}			//
		}
		epdf* predictor(const vec &cond) const {
			mxArray *tmp;
			mxArray *in[3];
			in[0]=data;
			in[1]=mxCreateDoubleMatrix(cond.length(),1,mxREAL);
			vec2mxArray(cond,in[1]);
			
			mexCallMATLAB(1, &tmp, 3, in, "predictor");
			
			UImxArray uitmp(tmp);
			shared_ptr<epdf> pred = UI::build<epdf>(uitmp);
			return pred.get();
			//
		}
		const epdf& posterior() const {
			return est;
		}
};
UIREGISTER(mexBM);